#!/usr/bin/perl

#
# Set defaults
#

$nolocal = 1;
$last = 0;
$count_by_host = 0;
$count_by_targethost = 0;
$count_by_parent = 0;
$start_line = 1;
$line_count = 0;
$max_lines = -1;
$only_parent_peer = 0;
$nodirect = 0;
$only_direct = 0;
$sep_parent = 0;
$sep_all_parents = 0;

$day_begin = 0;
$night_begin = 24;

$th_sep = " ";

$curmon = curmon();
$curyear = curyear();
$first_day = 1;
$last_day = 31;
$use_day_range = 0;
$use_m_range = 0;
$squid_prefix = "/usr/local/squid/logs";

#printf "curmon = $curmon\n";

$i = 0;
$curmon_ = $curmon+1;
$last_mon = $curmon_;
$orig_curmon = $curmon;

$fstart_pos = -1;

#
# Get parameters
#

while ($i <= $#ARGV) {
#  printf "$i $ARGV[$i]\n";
  if ($ARGV[$i] eq "\-last")
  {
    $last = 1;
    for($d = $ARGV[$i+1]; $d > 0; $d--) {
#      printf "d = $d ";
      if ($curmon == 0)
      {
        $curmon = 11;
        $curyear = $curyear-1;
      }
      else
      {
        $curmon--;
      }
    }
  }
  elsif ($ARGV[$i] eq "\-rotate") {
    $curmon_ = $curmon+1;
    $curyear_ = $curyear;
    system("mv $squid_prefix/access.log $squid_prefix/access.log.$curyear_.$curmon_");
    system("touch $squid_prefix/access.log");
    system("chown squid:squid $squid_prefix/access.log");
    printf "mv -n $squid_prefix/access.log $squid_prefix/access.log.$curyear.$curmon\n";
    printf "touch $squid_prefix/access.log\n";
    printf "chown squid:squid $squid_prefix/access.log\n";
    exit(0);
  }
  elsif ($ARGV[$i] eq "\-l") {
    $start_line = $ARGV[$i+1];
    $i++;
    printf "start line $start_line\n";
  }
  elsif ($ARGV[$i] eq "\-lseek") {
    $fstart_pos = $ARGV[$i+1];
    $i++;
    printf "start file position $fstart_pos\n";
  }
  elsif ($ARGV[$i] eq "\-day_begin") {
    $day_begin = $ARGV[$i+1];
    $i++;
  }
  elsif ($ARGV[$i] eq "\-night_begin") {
    $night_begin = $ARGV[$i+1];
    $i++;
  }
  elsif ($ARGV[$i] eq "\-parent") {
    $only_parent_peer = 1;
    $template_parent_peer = $ARGV[$i+1];
    $i++;
    printf "parent peer $template_parent_peer\n";
  }
  elsif ($ARGV[$i] eq "\-c") {
    $max_lines = $ARGV[$i+1];
    $i++;
  }
  elsif ($ARGV[$i] eq "\-sep_parent") {
    $sep_parent = 1;
  }
  elsif ($ARGV[$i] eq "\-sep_all_parents") {
    $sep_all_parents = 1;
  }
  elsif ($ARGV[$i] eq "\-nosep") {
    $th_sep = "";
  }
  elsif ($ARGV[$i] eq "\-nodirect") {
    $nodirect = 1;
  }
  elsif ($ARGV[$i] eq "\-direct") {
    $only_direct = 1;
  }
  elsif ($ARGV[$i] eq "\-d") {
    $curyear_ = $curyear;
    if($ARGV[$i+1] < 1) {
        $curmon += $ARGV[$i+1];
    } else {
        $curmon = $ARGV[$i+1]-1;
    }
    $curmon_ = $curmon+1;

    $i+=1;
    if(($i+1) <= $#ARGV) {
      if($ARGV[$i+1] eq "\-") {
        $first_day = 1;
        $last_day = 31;
      } else {
        $first_day = $last_day = $ARGV[$i+1];
        $i+=1;
      }
      $use_day_range = 1;
    }

    if(($i+1 <= $#ARGV) && ($ARGV[$i+1] eq "\-")) {
        $last_mon = $ARGV[$i+2];
        if($i+3 <= $#ARGV) {
          $last_day = $ARGV[$i+3];
          $i+=1;
        } else {
          $last_day = 31;
        }
        $i+=2;
        if($last_mon != $curmon) {
            $use_m_range = 1;
        }
    }
    if($orig_curmon != $curmon) {
        printf "orig_curmon = $orig_curmon , curmon = $curmon\n";
        $last = 1;
    }
  }
  elsif ($ARGV[$i] eq "\-byip") {
    $count_by_host = 1;
  }
  elsif ($ARGV[$i] eq "\-ip") {
    $only_host = 1;
    $only_host_ip = $ARGV[$i+1];
    $i++;
    printf "single client $only_host_ip\n";
  }
  elsif ($ARGV[$i] eq "\-bytargetip") {
    $count_by_targethost = 1;
  }
#  elsif ($ARGV[$i] eq "\-byparent") {
#    $count_by_parent = 1;
#  }
  else
  {
    #printf "Incorrect parameter (".$ARGV[$i]."). Resetted to default\n";
    #printf "use \-last to see statistics for last month\n";
    printf "Incorrect parameter (".$ARGV[$i].")\n";
  };
  $i++;
}; 

if($use_day_range == 0) {
    printf "Date: $curyear $curmon_\n";
} else {
    printf "Date: $curyear $curmon_ ($first_day)\n";
}


$imroot = 0;
$username = $ENV{'USER'};
if ("$username" eq "root")
{
  $imroot = 1;
};

#      (   ...)
$fileout = "access.html";

$getfirst = 1;
$localtraffic = 0;
$deniedtraffic = 0;
$cachedtraffic = 0;
$day_night=0;

$first_day_ = $first_day;

while($curmon < $last_mon) {

  #    ...
  if ($last == 1 && $curmon != $orig_curmon)
  {
    $curmon_ = $curmon+1;
    $curyear_ = $curyear;
    $filein = "$squid_prefix/access.log.$curyear_.$curmon_";
    $last_day_ = 31;
  }
  else
  {
    $filein = "$squid_prefix/access.log";
    $last_day_ = $last_day;
  };
  printf "filein = $filein\n";

  if($max_lines != -1) {
    $max_lines = $start_line + $max_lines;
  }

  $imroot = 1;

  open (LOGFILE, $filein);
  $flast_pos=0;
  if($fstart_pos != -1) {
    seek(LOGFILE, $fstart_pos, 0);
    if($start_line > 0) {
        $line_count = $start_line-1;
    }
  }
  MAIN_LOOP: while (($str = <LOGFILE>) && ($max_lines == -1 || $line_count < $max_lines))
  {
    $line_count ++;
    if($line_count < $start_line) {
      next MAIN_LOOP;
    };
    chomp ($str);
  #  ($time,$elapsed,$who,$tag,$size,$method,$what) = split (" ", $str);
    ($time,$elapsed,$iphost,$tag,$size,$method,$what,$who,$peer) = split (" ", $str);
    ($peer_type,$parent_peer) = split ("/", $peer);
    if($count_by_host == 1) {
      $who = $iphost;
    }
    if($count_by_targethost == 1) {
      $who = $parent_peer;
    }

    if(($imroot != 1) && !("$who" eq "$username")) {
      next MAIN_LOOP;
    };
    if(($only_parent_peer == 1) && !("$parent_peer" eq "$template_parent_peer")) {
      next MAIN_LOOP;
    };
    if(($only_host == 1) && !("$iphost" eq "$only_host_ip")) {
      next MAIN_LOOP;
    };
    if(("$peer_type" eq "DIRECT") || ("$peer_type" eq "NONE")) {
      $is_parent = 0;
      if($sep_all_parents == 1) {
        $who = "$who"."/"."$peer_type";
        #$who = "$who"."/"."DIRECT";
      }
    } else {
      $is_parent = 1;
      if($sep_all_parents == 1) {
        $who = "$who"."/"."$parent_peer";
      }
    }
    if(($nodirect == 1) && ($is_parent == 0)) {
      next MAIN_LOOP;
    };
    if(($only_direct == 1) && ($is_parent == 1)) {
      next MAIN_LOOP;
    };

    ($status,$errcode) = split ("/", $tag);

    if ($getfirst == 1)
    {
      $getfirst = 0;
      $btime = $time;
    };

    ($get_sec,$get_min,$get_hour,$get_day,$get_mon,$get_year,$get_wday,$get_yday,$get_isdst) = localtime($time);
    $get_year = $get_year+1900;

    $etime = $time;

    if ( ($use_day_range == 1 && $get_mon == $curmon &&
                                 $get_day >= $first_day_ && 
                                 $get_day <= $last_day_) ||
         ($use_day_range == 0 && $get_mon == $curmon) ) {
      if (($get_hour >= $day_begin) && ($get_hour < $night_begin)) {
        $day_night=0;
      } else {
        $day_night=1;
      }
      $column_idx=$day_night+($is_parent*2*$sep_parent);

      if ($clients {$who}[$column_idx] == "") {
        $clients {$who}[$column_idx] = 0;
      };
      if ($nolocal == 1) {
  #      if ( (($what =~ /ntu\-kpi\.kiev\.ua/)) ||
  #           (($what =~ /\:\/\/10\./)) ||
  #           (($what =~ /\:\/\/213\.133\.163\.18/))
        if ( ($what =~ /\:\/\/10\./) ||
             ($what =~ /\:\/\/193\.111\.250\.146/) ||
             ($what =~ /\:\/\/195\.140\.169\.146/) ||
             ($what =~ /\:\/\/195\.214\.209\.200/) ||
             ($what =~ /\:\/\/195\.214\.208\.1/) ||
             ($what =~ /\:\/\/127\.0\.0\.1/) ||
             ($what =~ /\:\/\/.*\.alfa-inet.kiev.ua/) ||
             ($what =~ /\:\/\/alfa-inet.kiev.ua/)
           )   
        {
          $localtraffic += $size;
          $size = 0;
          next MAIN_LOOP;
        }
      };

      if ($status eq "TCP_DENIED")
      {
        $deniedtraffic += $size;
        next MAIN_LOOP;
      } else {
        if("$peer_type" eq "NONE") {
          $cachedtraffic += $size;
          next MAIN_LOOP;
        }
      }

      $clients {$who}[$column_idx] += $size; 

#      if(($sep_parent == 0) || ($is_parent == 0)) {
#        if($day_night == 0) {
#          $monthly_d += $size;
#        } else {
#          $monthly_n += $size;
#        }
#      } else {
#        if($day_night == 0) {
#          $monthly_d_p += $size;
#        } else {
#          $monthly_n_p += $size;
#        }
#      }
      if($sep_all_parents == 1 && $sep_parent == 0) {
          $column_idx += $is_parent*2;
      }
      if($monthly[$column_idx] == "") {
        $monthly[$column_idx] = 0;
      }
      $monthly[$column_idx] += $size;
      $total += $size;
    };
    $etime = $time;
  }
  $flast_pos=tell(LOGFILE);
  close (LOGFILE);
  $curmon += 1;
  $first_day_ = 1;
  printf "new mon: $curmon\n";
}

# HTML-,     ...
# printf "HTTP 1.1/200 OK\n";
# printf "Content-type: text/plain; charset = koi8-r\n\n";

printf "This month:\n\n";
if($sep_parent == 0) {
  printf "  client                     day traffic         night traffic\n";
} else {
  printf "  client                     day direct traffic  night direct traffic  day parent traffic    night parent traffic\n";
}
printf "--------------------------+--------------------+--------------------\n";
foreach (sort keys %clients)
{
  $bytes_d   = $clients{$_}[0];
  $bytes_n   = $clients{$_}[1];
  $bytes_d_p = $clients{$_}[2];
  $bytes_n_p = $clients{$_}[3];
  if (($bytes_d > 0) or ($bytes_n > 0) or ($bytes_d_p > 0) or ($bytes_n_p > 0))
  {
#printf "i $_ i $username !\n";
    if(($imroot == 1) || ("$_" eq "$username"))
    {
      $bytes_d   = n2str ($bytes_d);
      $bytes_n   = n2str ($bytes_n);
      $bytes_d_p = n2str ($bytes_d_p);
      $bytes_n_p = n2str ($bytes_n_p);
      $_ = c2str ($_);
      if($sep_parent == 0) {
        printf "$_         $bytes_d $bytes_n\n";
      } else {
        printf "$_         $bytes_d $bytes_n $bytes_d_p $bytes_n_p\n";
      }
    };
  };
};
printf "--------------------------+--------------------+--------------------\n";
$monthly_d = n2str ($monthly[0]);
$monthly_n = n2str ($monthly[1]);
$monthly_d_p = n2str ($monthly[2]);
$monthly_n_p = n2str ($monthly[3]);
#if($sep_all_parents == 0) {
  if($sep_parent == 0 && $sep_all_parents == 0) {
    printf "Total        $monthly_d $monthly_n\n";
  } else {
    printf "Total        $monthly_d $monthly_n $monthly_d_p $monthly_n_p\n";
  }
#} else {
#}
$localtraffic = n2str ($localtraffic);
printf "Local        $localtraffic\n";
$den_traf     = n2str ($deniedtraffic);
printf "Blocked      $den_traf\n";
$cache_traf   = n2str($cachedtraffic);
printf "Cached       $cache_traf\n";
$total        = n2str ($total);
printf "External     $total\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($btime);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "Log started    $mday $mon_ $year\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($etime);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "Log stopped    $mday $mon_ $year\n";
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
$year = 1900+$year;
$mon_ = mon2str($mon+1);
$mday = mon2str($mday);
printf "Now            $mday $mon_ $year\n";
$lc = $line_count - $start_line;
printf "processed $lc lines\n";
$nl = $line_count;
printf "next line $nl\n";
printf "filepos $flast_pos\n";

sub curmon
{
  ($sec,$min,$hour,$mday,$cmon,$year,$wday,$yday,$isdst) = localtime(time);
  return $cmon;
};

sub curyear
{
  ($sec,$min,$hour,$mday,$cmon,$year,$wday,$yday,$isdst) = localtime(time);
  return 1900+$year;
};


#sub getmon 
#{
#  ($sec,$min,$hour,$mday,$gmon,$year,$wday,$yday,$isdst) = localtime($_[0]);
#printf "m: $gmon\n";
#  return $gmon;
#};

#sub gethour
#{
#  ($sec,$min,$ghour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($_[0]);
#  return $ghour;                                                             
#};

sub n2str
{
  $res = " bytes";
  $i = 1;
  if(length($_[0]) < 1) {
    $_[0] = 0;
  }
  foreach $byte (reverse split //, $_[0])
  {
    if ($i == 3)
    {
      $i = 1;
      $byte = "$th_sep" . $byte;
    }
    else
    {
      $i++
    }
    $res = $byte . $res;
  };
  $res = " " x (20 - length ($res)) . $res;
  return $res;
};

sub c2str
{
  $res = $_[0];
  $res = " " x (16 - length ($res)) . $res;
  return $res;
};

sub mon2str
{
  $res = $_[0];
  if($res < 10) {
    $res = " $res";
  }
  return $res;
};
